## org.apache.batik.dom.svg
Class AbstractElement

    java.lang.Object
      org.apache.batik.dom.AbstractNode
          org.apache.batik.dom.AbstractParentNode
              org.apache.batik.dom.AbstractParentChildNode
                  org.apache.batik.dom.AbstractElement
                      org.apache.batik.dom.svg.AbstractElement

All Implemented Interfaces:
  org.w3c.dom.Element, org.w3c.dom.events.EventTarget, ExtendedNode, org.w3c.dom.Node, NodeEventTarget, java.io.Serializable

Direct Known Subclasses:
  SVGOMElement

public abstract class AbstractElement
extends AbstractElement
implements NodeEventTarget

This class provides a superclass to implement an SVG element, or an element interoperable with the SVG elements.

See Also:
  Serialized Form

Nested Class Summary
`protected class` `AbstractElement.ExtendedNamedNodeHashMap` An implementation of the `NamedNodeMap`.

Nested classes inherited from class org.apache.batik.dom.AbstractElement
`AbstractElement.Entry, AbstractElement.NamedNodeHashMap`

Nested classes inherited from class org.apache.batik.dom.AbstractParentNode
`AbstractParentNode.ChildNodes, AbstractParentNode.ElementsByTagName, AbstractParentNode.ElementsByTagNameNS`

Field Summary
`protected SoftDoublyIndexedTable` `liveAttributeValues` The live attribute values.

Fields inherited from class org.apache.batik.dom.AbstractElement
`attributes`

Fields inherited from class org.apache.batik.dom.AbstractParentChildNode
`nextSibling, parentNode, previousSibling`

Fields inherited from class org.apache.batik.dom.AbstractParentNode
`childNodes`

Fields inherited from class org.apache.batik.dom.AbstractNode
`EMPTY_NODE_LIST, eventSupport, ownerDocument`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`protected` `AbstractElement()` Creates a new Element object.
`protected` `AbstractElement(java.lang.String prefix, AbstractDocument owner)` Creates a new Element object.

Method Summary
`protected void` `attrAdded(org.w3c.dom.Attr node, java.lang.String newv)` Called when an attribute has been added.
`protected void` `attrModified(org.w3c.dom.Attr node, java.lang.String oldv, java.lang.String newv)` Called when an attribute has been modified.
`protected void` `attrRemoved(org.w3c.dom.Attr node, java.lang.String oldv)` Called when an attribute has been removed.
`protected org.w3c.dom.NamedNodeMap` `createAttributes()` Creates the attribute list.
`protected org.w3c.dom.Node` `deepExport(org.w3c.dom.Node n, AbstractDocument d)` Deeply exports this node to the given document.
`protected org.w3c.dom.Node` `export(org.w3c.dom.Node n, AbstractDocument d)` Exports this node to the given document.
`protected AttributeInitializer` `getAttributeInitializer()` Returns the AttributeInitializer for this element type.
`LiveAttributeValue` `getLiveAttributeValue(java.lang.String ns, java.lang.String ln)` Returns the live attribute value associated with given attribute, if any.
`NodeEventTarget` `getParentNodeEventTarget()` Implements `NodeEventTarget.getParentNodeEventTarget()`.
`protected void` `initializeAttributes()` Initializes the attributes of this element to their default value.
`void` `putLiveAttributeValue(java.lang.String ns, java.lang.String ln, LiveAttributeValue val)` Associates a live attribute value to this element.
`protected boolean` `resetAttribute(java.lang.String ns, java.lang.String prefix, java.lang.String ln)` Resets an attribute to the default value.
`void` `setUnspecifiedAttribute(java.lang.String nsURI, java.lang.String name, java.lang.String value)` Sets an unspecified attribute.

Methods inherited from class org.apache.batik.dom.AbstractElement
`checkChildType, copyInto, deepCopyInto, fireDOMAttrModifiedEvent, getAttribute, getAttributeNode, getAttributeNodeNS, getAttributeNS, getAttributes, getNodeType, getTagName, hasAttribute, hasAttributeNS, hasAttributes, nodeAdded, nodeToBeRemoved, normalize, removeAttribute, removeAttributeNode, removeAttributeNS, setAttribute, setAttributeNode, setAttributeNodeNS, setAttributeNS`

Methods inherited from class org.apache.batik.dom.AbstractParentChildNode
`getNextSibling, getParentNode, getPreviousSibling, setNextSibling, setParentNode, setPreviousSibling`

Methods inherited from class org.apache.batik.dom.AbstractParentNode
`appendChild, checkAndRemove, fireDOMNodeInsertedEvent, fireDOMNodeInsertedIntoDocumentEvent, fireDOMNodeRemovedEvent, fireDOMNodeRemovedFromDocumentEvent, fireDOMSubtreeModifiedEvent, getChildNodes, getElementsByTagName, getElementsByTagNameNS, getFirstChild, getLastChild, hasChildNodes, insertBefore, removeChild, replaceChild`

Methods inherited from class org.apache.batik.dom.AbstractNode
`addEventListener, cloneNode, createDOMException, dispatchEvent, fireDOMCharacterDataModifiedEvent, getCurrentDocument, getEventSupport, getLocalName, getNamespaceURI, getNodeValue, getOwnerDocument, getPrefix, isSupported, newNode, removeEventListener, setNodeName, setNodeValue, setOwnerDocument, setPrefix, setSpecified`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.batik.dom.events.NodeEventTarget
`getEventSupport`

Methods inherited from interface org.w3c.dom.events.EventTarget
`addEventListener, dispatchEvent, removeEventListener`

Methods inherited from interface org.w3c.dom.Element
`getElementsByTagName, getElementsByTagNameNS`

Methods inherited from interface org.w3c.dom.Node
`appendChild, cloneNode, getChildNodes, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, hasChildNodes, insertBefore, isSupported, removeChild, replaceChild, setNodeValue, setPrefix`

Methods inherited from interface org.apache.batik.dom.ExtendedNode
`isReadonly, setReadonly`

Field Detail

### liveAttributeValues

    protected transient SoftDoublyIndexedTable liveAttributeValues

  The live attribute values.

Constructor Detail

### AbstractElement

    protected AbstractElement()

  Creates a new Element object.

### AbstractElement

    protected AbstractElement(java.lang.String prefix,
                              AbstractDocument owner)

  Creates a new Element object.

Parameters:
  `prefix` - The namespace prefix.
  `owner` - The owner document.

Method Detail

### getParentNodeEventTarget

    public NodeEventTarget getParentNodeEventTarget()

  Implements `NodeEventTarget.getParentNodeEventTarget()`.

  Specified by:
    `getParentNodeEventTarget` in interface `NodeEventTarget`
  Overrides:
    `getParentNodeEventTarget` in class `AbstractNode`

### getLiveAttributeValue

    public LiveAttributeValue getLiveAttributeValue(java.lang.String ns,
                                                    java.lang.String ln)

  Returns the live attribute value associated with given attribute, if any.

  Parameters:
    `ns` - The attribute's namespace.
    `ln` - The attribute's local name.

### putLiveAttributeValue

    public void putLiveAttributeValue(java.lang.String ns,
                                      java.lang.String ln,
                                      LiveAttributeValue val)

  Associates a live attribute value to this element.

  Parameters:
    `ns` - The attribute's namespace.
    `ln` - The attribute's local name.
    `val` - The live value.

### getAttributeInitializer

    protected AttributeInitializer getAttributeInitializer()

  Returns the AttributeInitializer for this element type.

  Returns:
    null if this element has no attribute with a default value.

### initializeAttributes

    protected void initializeAttributes()

  Initializes the attributes of this element to their default value.

### resetAttribute

    protected boolean resetAttribute(java.lang.String ns,
                                     java.lang.String prefix,
                                     java.lang.String ln)

  Resets an attribute to the default value.

  Returns:
    true if a default value is known for the given attribute.

### createAttributes

    protected org.w3c.dom.NamedNodeMap createAttributes()

  Creates the attribute list.

  Overrides:
    `createAttributes` in class `AbstractElement`

### setUnspecifiedAttribute

    public void setUnspecifiedAttribute(java.lang.String nsURI,
                                        java.lang.String name,
                                        java.lang.String value)

  Sets an unspecified attribute.

  Parameters:
    `nsURI` - The attribute namespace URI.
    `name` - The attribute's qualified name.
    `value` - The attribute's default value.

### attrAdded

    protected void attrAdded(org.w3c.dom.Attr node,
                             java.lang.String newv)

  Called when an attribute has been added.

  Overrides:
    `attrAdded` in class `AbstractElement`

### attrModified

    protected void attrModified(org.w3c.dom.Attr node,
                                java.lang.String oldv,
                                java.lang.String newv)

  Called when an attribute has been modified.

  Overrides:
    `attrModified` in class `AbstractElement`

### attrRemoved

    protected void attrRemoved(org.w3c.dom.Attr node,
                               java.lang.String oldv)

  Called when an attribute has been removed.

  Overrides:
    `attrRemoved` in class `AbstractElement`

### export

    protected org.w3c.dom.Node export(org.w3c.dom.Node n,
                                      AbstractDocument d)

  Exports this node to the given document.

  Overrides:
    `export` in class `AbstractElement`
  Parameters:
    `n` - The clone node.
    `d` - The destination document.

### deepExport

    protected org.w3c.dom.Node deepExport(org.w3c.dom.Node n,
                                          AbstractDocument d)

  Deeply exports this node to the given document.

  Overrides:
    `deepExport` in class `AbstractElement`
  Parameters:
    `n` - The clone node.
    `d` - The destination document.

Copyright © 2004 Apache Software Foundation. All Rights Reserved.